//+------------------------------------------------------------------+
//|                                                        |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005 "
#property  link      "http://www.metaquotes.net/"

//---- indicator settings
#property indicator_separate_window
#property  indicator_buffers 3
#property indicator_color1 Yellow      
#property indicator_color2 Green
#property indicator_color3 Red

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
int width;

extern int Rperiod1 = 28;
extern int Rperiod2 = 14;
extern int Rperiod3 = 7;
extern int Rperiod4 = 1;
extern int Draw4HowLongg = 1500;
int Draw4HowLong;
int shift;
int i;
int loopbegin;
double sum[];
int length;
double lengthvar;
double tmp ;
double wt1[],wt2[],wt3[],wt4[],wt1sum,wt2sum,wt3sum,wt4sum;
int c;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(8);
   
//---- drawing settings
   SetIndexBuffer(2,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(0,ExtMapBuffer3);
   SetIndexBuffer(3,sum);
   SetIndexBuffer(4,wt1);
   SetIndexBuffer(5,wt2);
   SetIndexBuffer(6,wt3);
   SetIndexBuffer(7,wt4);
   
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);

//---- initialization done
   return(0);
  }

int start()
      {
      Draw4HowLong = Bars-Rperiod1 - 5;
      length = Rperiod1;
      loopbegin = Draw4HowLong - length - 1;
 
      for(shift = loopbegin; shift >= 0; shift--)
      { 
         sum[1] = 0;
         for(i = length; i >= 1  ; i--)
         {
         lengthvar = length + 1;
         lengthvar /= 3;
         tmp = 0;
         tmp = ( i - lengthvar)*Close[length-i+shift];
         sum[1]+=tmp;
         }
         wt1[shift] = sum[1]*6/(length*(length+1));
        }
         
         
       
      length = Rperiod2;
      loopbegin = Draw4HowLong - length - 1;
 
      for(shift = loopbegin; shift >= 0; shift--)
      { 
         sum[1] = 0;
         for(i = length; i >= 1  ; i--)
         {
         lengthvar = length + 1;
         lengthvar /= 3;
         tmp = 0;
         tmp = ( i - lengthvar)*Close[length-i+shift];
         sum[1]+=tmp;
         }
         wt2[shift] = sum[1]*6/(length*(length+1));
         }
         
         
         
      length = Rperiod3;
      loopbegin = Draw4HowLong - length - 1;
 
      for(shift = loopbegin; shift >= 0; shift--)
      { 
         sum[1] = 0;
         for(i = length; i >= 1  ; i--)
         {
         lengthvar = length + 1;
         lengthvar /= 3;
         tmp = 0;
         tmp = ( i - lengthvar)*Close[length-i+shift];
         sum[1]+=tmp;
         }
         wt3[shift] = sum[1]*6/(length*(length+1));
         }
         
       
      length = Rperiod4;
      loopbegin = Draw4HowLong - length - 1;
 
      for(shift = loopbegin; shift >= 0; shift--)
      { 
         sum[1] = 0;
         for(i = length; i >= 1  ; i--)
         {
         lengthvar = length + 1;
         lengthvar /= 3;
         tmp = 0;
         tmp = ( i - lengthvar)*Close[length-i+shift];
         sum[1]+=tmp;
         }
         wt4[shift] = sum[1]*6/(length*(length+1));
         }
         
         
//========== COLOR CODING ===========================================               
       for(shift = loopbegin; shift >= 0; shift--)
      { 
    //  Comment("                     ", wt1[shift], wt2[shift], wt3[shift], wt4[shift]);
       
       
  
        if (wt1[shift+1] > wt1[shift])
        {
        wt1sum = -5;
        
        ExtMapBuffer2[shift+2] = EMPTY_VALUE;
       
  
        
        }
       else if (wt1[shift+1] < wt1[shift]) 
        {
        wt1sum = 5;
        ExtMapBuffer2[shift+2] = EMPTY_VALUE;
        
       
        
        }
         else 
         {
       //  wt1sum = 0;
         ExtMapBuffer1[shift+2]=CLR_NONE;//EMPTY_VALUE;
         ExtMapBuffer2[shift+2]=CLR_NONE;//EMPTY_VALUE;
         }
        
      
      
      
      
       if (wt2[shift+1] > wt2[shift])
        {
        wt2sum = -1;
        ExtMapBuffer2[shift+2] = EMPTY_VALUE;
       
  
        
        }
       else if (wt2[shift+1] < wt2[shift]) 
        {
        wt2sum = 1;
        ExtMapBuffer2[shift+2] = EMPTY_VALUE;
        
       
        
        }
         else 
         {
        // wt2sum = 0;
         ExtMapBuffer1[shift+2]=CLR_NONE;//EMPTY_VALUE;
         ExtMapBuffer2[shift+2]=CLR_NONE;//EMPTY_VALUE;
         }
      
      
      
       if (wt3[shift+1] > wt3[shift])
        {
        wt3sum = -0.5;
        ExtMapBuffer2[shift+2] = EMPTY_VALUE;
       
  
        
        }
       else if (wt3[shift+1] < wt3[shift]) 
        {
        wt3sum = 0.5;
        ExtMapBuffer2[shift+2] = EMPTY_VALUE;
        
       
        
        }
         else 
         {
        // wt3sum = 0;
         ExtMapBuffer1[shift+2]=CLR_NONE;//EMPTY_VALUE;
         ExtMapBuffer2[shift+2]=CLR_NONE;//EMPTY_VALUE;
         }
      
      
      
       if (wt4[shift+1] > wt4[shift])
        {
        wt4sum = -0.25;
        ExtMapBuffer2[shift+2] = EMPTY_VALUE;
       
  
        
        }
       else if (wt4[shift+1] < wt4[shift]) 
        {
        wt4sum = 0.25;
        ExtMapBuffer2[shift+2] = EMPTY_VALUE;
        
       
        
        }
         else 
         {
         
         
       //  wt4sum = 0;
         ExtMapBuffer1[shift+2]=CLR_NONE;//EMPTY_VALUE;
         ExtMapBuffer2[shift+2]=CLR_NONE;//EMPTY_VALUE;
         }
         
         
          if (wt4[shift] > wt1[shift] && wt1sum == -5)  wt1sum = 0;
         if (wt4[shift] < wt1[shift] && wt1sum == 5)  wt1sum = -0;
         ExtMapBuffer2[shift] = wt4sum+wt3sum+wt2sum+wt1sum; //red
         ExtMapBuffer1[shift] = wt4sum+wt3sum+wt2sum+wt1sum; //red
         ExtMapBuffer3[shift] = wt4sum+wt3sum+wt2sum+wt1sum; //red
         Comment("Sentiment is ",wt4sum+wt3sum+wt2sum+wt1sum);
         }
        
         
            
         
         }
         
    
      return(0);
  
  
//+------------------------------------------------------------------+



